#pragma once

#include <vector>
#include <list>
#include "TransScriptParser.h"

using namespace std;

class COptionNode;
class CTransCommand;

//////////////////////////////////////////////////////////////////////////
class CHookPoint
{
private:
	static int	m_nKernelVer;
	HMODULE		m_hModule;
	UINT_PTR	m_pCodePoint;
	CString		m_strModuleName;
	CTransScriptParser m_parser;
	vector<CTransCommand*> m_vectorTransCmd;

	CHookPoint();
	void ExecuteTransCmds(PREGISTER_ENTRY pRegisters);
	BOOL EncodeMultiBytes(LPSTR szKorean);
	BOOL EnforceTwoBtye(LPSTR szText);
	BOOL EnforceOneBtye(LPSTR szText, LPWSTR wszText);
	BOOL ReduceSpaceA(LPSTR szText, int nSizeTo);
	BOOL EnforceAddNull(LPSTR szText, LPWSTR wszText, CTransCommand* pCmd);
	BOOL AnsiError(LPWSTR wszText);
	BOOL DecodeJ2K(LPCSTR cszJpnCode, LPSTR szKorCode);
	BOOL EndCharAdd(CTransCommand* pCmd, LPVOID pOrigBasePtr, CTransScriptParser *pParser);
	BOOL TranslateScript(LPCWSTR cwszSrc, LPWSTR wszTar);
	BOOL TranslateUnicodeText(LPCWSTR cwszSrc, LPWSTR wszTar);
	int  GetTotalLines(LPCWSTR cwszText);
	BOOL GetNextLine(LPWSTR& wszBuf, CString& strLine);
	static void PointCallback(LPVOID pHookedPoint, PREGISTER_ENTRY pRegisters);

public:
	static bool IsWinVistaAndAbove();
	static CHookPoint* CreateInstance(CString strAddr);
	~CHookPoint();

	UINT_PTR		GetHookAddress();
	CString			GetHookAddressString();
	
	CTransCommand*	AddTransCmd(COptionNode *pNode);
	CTransCommand*	FindTransCmd(CString strArgScript);

	int				GetTransCmdCount();	
	CTransCommand*	GetTransCmd(int nIdx);
	void			DeleteTransCmd(int nIdx);
	void			DeleteAllTransCmd();
};
